/*
 * Copyright (c) 2021-2022, Kyungguk Min
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

#ifndef ParallelKit_MPIRequest_h
#define ParallelKit_MPIRequest_h

#include <ParallelKit/ParallelKit-config.h>

#include <utility>

#include <ParallelKit/mpi_wrapper.h>

PARALLELKIT_NAMESPACE_BEGIN(1)
namespace mpi {

// forward decls
//
/// @cond
template <class> class P2P;
class Comm;
/// @endcond

/// Wrapper for `MPI_Request` token.
///
class Request {
    friend P2P<Comm>;

private:
    MPI_Request m_request{ MPI_REQUEST_NULL };

    explicit Request(MPI_Request r) noexcept : m_request{ r } {}

public:
    ~Request();
    Request() noexcept = default;

    /// @{
    Request(Request &&o) noexcept { std::swap(m_request, o.m_request); }
    Request &operator=(Request &&o) noexcept
    {
        std::swap(m_request, o.m_request);
        return *this;
    }
    /// @}

    /// Returns `true` if the request is not null.
    ///
    explicit operator bool() const noexcept { return m_request != MPI_REQUEST_NULL; }

    /// Block until the request is done.
    /// @note One is allowed to call wait() even if `*this` is a null or inactive.
    /// In this case, the operation returns immediately.
    ///
    void wait() &&;

    /// Return `true` if the request is done and set the internal token to `MPI_REQUEST_NULL`;
    /// otherwise, return `false`.
    /// @note One is allowed to call `test()` even if `*this` is a null or inactive.
    /// In such a case, the operation returns `true`.
    ///
    [[nodiscard]] bool test() &;

    /// Marks for cancellation a pending, nonblocking communication operation (send or receive).
    /// @details The cancel call is local.
    /// It returns immediately, possibly before the communication is actually cancelled.
    ///
    /// The intended sequence of calls are "Create Persistent Request (Start Complete)*n Free",
    /// where the repetition count *n >= 0*.
    ///
    /// It is still necessary to call `MPI_REQUEST_FREE`, `MPI_WAIT` or `MPI_TEST` (or any of the
    /// derived operations) with the cancelled request as argument after the call to `MPI_CANCEL`.
    /// `*this` should not be a null request.
    ///
    void cancel() &&;

    /// Initiates a communication (send or receive) that uses a persistent request, `*this`.
    /// @details The associated request should be inactive.
    /// The request becomes active once the call is made.
    ///
    /// A send operation initiated with `MPI_START` can be matched with any receive operation and,
    /// likewise, a receive operation initiated with `MPI_START` can receive messages generated by
    /// any send operation.
    ///
    void start() &;
};

} // namespace mpi
PARALLELKIT_NAMESPACE_END(1)

#endif /* ParallelKit_MPIRequest_h */
